diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/config.h ircd-hybrid-6.0/include/config.h
--- ircd-hybrid-6.0.orig/include/config.h	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/include/config.h	Wed Jun 20 02:39:38 2001
@@ -48,19 +48,12 @@
  * The C/N lines passwords are used to generate the hashes used and it 
  * is adviceable to use a diffrent pass for C and N.
  *
- * To allow fallback to PASS, add
- *  #define CHALLENGERESPONSE_FALLBACK
- *  #define CHALLENGERESPONSE_EXPIRY  30
- *
- * CHALLENGERESPONSE_EXPIRY is defined in seconds.
+ * To accept PASS (although never send it) define CHALLENGERESPONSE_FALLBACK
  *
  */
 
 #define CHALLENGERESPONSE
 #define CHALLENGERESPONSE_FALLBACK
-#undef CHALLENGERESPONSE_EXPIRY
-
-
 
 /***************** MAKE SURE THIS IS CORRECT!!!!!!!!! **************/
 /* ONLY EDIT "HARD_FDLIMIT_" and "INIT_MAXCLIENTS" */
@@ -809,8 +802,10 @@
  * LWALLOPS - Like wallops but only local.
  *
  * This is actually a compatibility command which really calls m_locops().
+ *
+ * nah -- asuffield
  */
-#define LWALLOPS
+#undef LWALLOPS
 
 /*
  * Define this to enable WintrHawk "styling"
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/msg.h ircd-hybrid-6.0/include/msg.h
--- ircd-hybrid-6.0.orig/include/msg.h	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/include/msg.h	Tue Jun 19 20:00:30 2001
@@ -132,7 +132,7 @@
 #define MSG_MAKEPASS "MAKEPASS" /* MAKEPASS */
 #define MSG_STOPIC   "STOPIC"   /* STOPIC */
 
-#define MSG_LOCOPS   "LOCOPS"   /* LOCOPS */
+/*#define MSG_LOCOPS   "LOCOPS"  */ /* LOCOPS */ /* nah -- asuffield */
 #ifdef LWALLOPS
 #define MSG_LWALLOPS "LWALLOPS" /* Same as LOCOPS */
 #endif /* LWALLOPS */
@@ -200,7 +200,7 @@
   { MSG_INVITE,  m_invite,   0, MAXPARA, 1, 0, 0, 0L },
   { MSG_KICK,    m_kick,     0, MAXPARA, 1, 0, 0, 0L },
   { MSG_WALLOPS, m_wallops,  0, MAXPARA, 1, 0, 0, 0L },
-  { MSG_LOCOPS,  m_locops,   0, MAXPARA, 1, 0, 0, 0L },
+			   /*  { MSG_LOCOPS,  m_locops,   0, MAXPARA, 1, 0, 0, 0L },*/
 #ifdef LWALLOPS
   { MSG_LWALLOPS,m_locops,   0, MAXPARA, 1, 0, 0, 0L },
 #endif /* LWALLOPS */
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/send.h ircd-hybrid-6.0/include/send.h
--- ircd-hybrid-6.0.orig/include/send.h	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/include/send.h	Wed Jun 20 02:24:55 2001
@@ -55,15 +55,6 @@
 extern  void sendto_match_butone(struct Client *, struct Client *, 
                                  char *, int, const char *, ...);
 
-extern  void sendto_ops_flag(int, const char *, ...);
-
-extern  void sendto_realops(const char *, ...);
-extern  void sendto_realops_flag(int, const char *, ...);
-extern  void sendto_realops_flags(int*, const char *, ...);
-
-extern  void sendto_ops(const char *, ...);
-extern  void sendto_ops_butone(struct Client *, struct Client *, 
-                               const char *, ...);
 extern  void sendto_wallops_butone(struct Client *, struct Client *, 
                                    const char *, ...);
 extern  void ts_warn(const char *, ...);
@@ -79,6 +70,9 @@
 #define MATCH_SERVER  1
 #define MATCH_HOST    2
 
+extern  void sendto_ops_flag(int, const char *, ...);
 extern  void sendto_ops_flag_butone(struct Client *, int, const char *, ...);
+extern  void sendto_ops_flag_butone_from(struct Client *, int, struct Client*, const char *, ...);
+extern  void sendto_ops_flag_butone_hidefrom(struct Client *, int, const char *, ...);
 
 #endif /* INCLUDED_send_h */
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/blalloc.c ircd-hybrid-6.0/src/blalloc.c
--- ircd-hybrid-6.0.orig/src/blalloc.c	Sat Jul 31 09:22:56 1999
+++ ircd-hybrid-6.0/src/blalloc.c	Tue Jun 19 20:00:46 2001
@@ -16,6 +16,7 @@
 
 #ifdef DEBUG_BLOCK_ALLOCATOR
 #include "send.h"           /* sendto_ops */
+#include "client.h"
 
 const char* BH_CurrentFile = 0;   /* GLOBAL used for BlockHeap debugging */
 int         BH_CurrentLine = 0;   /* GLOBAL used for BlockHeap debugging */
@@ -278,11 +279,11 @@
 #ifdef DEBUG_BLOCK_ALLOCATOR
       log(L_WARN, "blalloc.c bit already clear in map caller %s %d",
           BH_CurrentFile, BH_CurrentLine);
-      sendto_ops("blalloc.c bit already clear in map elemSize %d caller %s %d",
-                         bh->elemSize,
-                         BH_CurrentFile,
-                         BH_CurrentLine);
-              sendto_ops("Please report to the hybrid team! ircd-hybrid@the-project.org");
+      sendto_ops_flag(UMODE_DEBUG, "blalloc.c bit already clear in map elemSize %d caller %s %d",
+			     bh->elemSize,
+			     BH_CurrentFile,
+			     BH_CurrentLine);
+      sendto_ops_flag(UMODE_DEBUG, "Please report to the dancer-hybrid team! opn-coders@vc.bc.ca");
 #endif /* DEBUG_BLOCK_ALLOCATOR */
             }
           else
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/channel.c ircd-hybrid-6.0/src/channel.c
--- ircd-hybrid-6.0.orig/src/channel.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/channel.c	Tue Jun 19 16:45:28 2001
@@ -226,7 +226,7 @@
       list = &chptr->invexlist;
       break;
     default:
-      sendto_realops("add_id() called with unknown ban type %d!", type);
+      sendto_ops_flag(UMODE_DEBUG, "add_id() called with unknown ban type %d!", type);
       return -1;
     }
 
@@ -306,7 +306,7 @@
       list = &chptr->invexlist;
       break;
     default:
-      sendto_realops("del_id() called with unknown ban type %d!", type);
+      sendto_ops_flag(UMODE_DEBUG, "del_id() called with unknown ban type %d!", type);
       return -1;
     }
 
@@ -2085,9 +2085,9 @@
 		  *mbufw++ = 'j';
                   len += 2;
 
-                  sendto_realops("%s!%s@%s juping channel %s",
-                                 sptr->name, sptr->username,
-                                 sptr->host, chptr->chname);
+                  sendto_ops_flag(UMODE_SERVNOTICE, "%s!%s@%s juping channel %s",
+					  sptr->name, sptr->username,
+					  sptr->host, chptr->chname);
                 }
               else if(whatt == MODE_DEL)
                 {
@@ -2096,9 +2096,9 @@
 		  *mbufw++ = 'j';
                   len += 2;
 
-                  sendto_realops("%s!%s@%s unjuping channel %s",
-                                 sptr->name, sptr->username,
-                                 sptr->host, chptr->chname);
+                  sendto_ops_flag(UMODE_SERVNOTICE, "%s!%s@%s unjuping channel %s",
+					  sptr->name, sptr->username,
+					  sptr->host, chptr->chname);
                 }
             }
           break;
@@ -2525,9 +2525,9 @@
   if( chptr->mode.mode & MODE_JUPED )
     {
       sendto_ops_flag(UMODE_SPY,
-		      "User %s (%s@%s) is attempting to join juped channel %s",
-		      sptr->name,
-		      sptr->username, sptr->host,chptr->chname);
+			     "User %s (%s@%s) is attempting to join juped channel %s",
+			     sptr->name,
+			     sptr->username, sptr->host,chptr->chname);
       return (ERR_BADCHANNAME);
     }
 #endif
@@ -2631,7 +2631,7 @@
 
 #ifdef CHANNEL_CREATION_NOTICE
       if(IsPerson(cptr) && !IsServer(cptr)) {
-        sendto_ops_flag_butone(NULL, UMODE_CHCREATE, "Channel %s created by %s!%s@%s on %s", chptr->chname, cptr->name, 
+        sendto_ops_flag(UMODE_CHCREATE, "Channel %s created by %s!%s@%s on %s", chptr->chname, cptr->name, 
 			       cptr->username, cptr->host, me.name);
       }
 #endif /* CHANNEL_CREATION_NOTICE */
@@ -3096,10 +3096,6 @@
 	   * strictly speaking its an error. However, if this entry is
 	   * ignored, its a non fatal one.
 	   */
-#if 0
-          sendto_ops("non zero user count in remove_empty_channels");
-          sendto_ops("Please report to the hybrid team! ircd-hybrid@the-project.org");
-#endif
           empty_channel_list->next_empty_channel = (struct Channel *)NULL;
           empty_channel_list->last_empty_channel = (struct Channel *)NULL;
           continue;
@@ -3297,7 +3293,7 @@
             {
               if(SPAMNUM && (sptr->join_leave_count >= SPAMNUM))
                 {
-                  sendto_ops_flag_butone(NULL, UMODE_BOTS,
+                  sendto_ops_flag(UMODE_BOTS,
 					 "User %s (%s@%s) is a possible spambot",
 					 sptr->name,
 					 sptr->username, sptr->host);
@@ -3393,7 +3389,7 @@
  
               if(sptr->oper_warn_count_down == 0)
                 {
-                  sendto_ops_flag_butone(NULL, UMODE_BOTS,
+                  sendto_ops_flag(UMODE_BOTS,
 					 "User %s (%s@%s) trying to join %s is a possible spambot",
 					 sptr->name,
 					 sptr->username,
@@ -3621,7 +3617,7 @@
         {
           if(SPAMNUM && (sptr->join_leave_count >= SPAMNUM))
             {
-              sendto_ops_flag_butone(NULL, UMODE_BOTS,
+              sendto_ops_flag(UMODE_BOTS,
 				     "User %s (%s@%s) is a possible spambot",
 				     sptr->name,
 				     sptr->username, sptr->host);
@@ -3763,8 +3759,8 @@
       return 0;
     }
   if (IsServer(sptr))
-    sendto_ops("KICK from %s for %s %s",
-               parv[0], parv[1], parv[2]);
+    sendto_ops_flag(UMODE_SPY, "KICK from %s for %s %s",
+			    parv[0], parv[1], parv[2]);
   comment = (BadPtr(parv[3])) ? parv[0] : parv[3];
   if (strlen(comment) > (size_t) TOPICLEN)
     comment[TOPICLEN] = '\0';
@@ -3887,7 +3883,7 @@
       remove_user_from_channel(who, chptr, 1);
       if (MyClient(sptr))
 #ifdef GODOPERS
-        sendto_ops_flag_butone(NULL, UMODE_BOTS,
+        sendto_ops_flag(UMODE_BOTS,
 			       "Kick from %s by %s on %s (%s@%s) [%s]",
 			       name, sptr->name, who->name,
 			       who->username, who->host, who->user->server);
@@ -4380,9 +4376,9 @@
                   s++;
                   *s = '\0';
                 }
-              sendto_realops("POSSIBLE /names abuser %s [%s]",
-                             para,
-                             get_client_name(sptr,FALSE));
+              sendto_ops_flag(UMODE_BOTS, "POSSIBLE /names abuser %s [%s]",
+				      para,
+				      get_client_name(sptr,FALSE));
               sendto_one(sptr, form_str(ERR_TOOMANYTARGETS),
                          me.name, sptr->name, "NAMES",1);
               return 0;
@@ -4746,8 +4742,8 @@
       sendto_channel_butserv(chptr, &me,
              ":%s NOTICE %s :*** Notice -- TS for %s changed from %lu to 0",
               me.name, chptr->chname, chptr->chname, oldts);
-      sendto_realops("Server %s changing TS on %s from %lu to 0",
-                     sptr->name,parv[2],oldts);
+      sendto_ops_flag(UMODE_SERVNOTICE, "Server %s changing TS on %s from %lu to 0",
+			      sptr->name,parv[2],oldts);
     }
 
   doesop = (parv[4+args][0] == '@' || parv[4+args][1] == '@');
@@ -4796,9 +4792,9 @@
 
           if (MyConnect(sptr) && !isnew)
             {
-              sendto_realops("Hacked ops from %s on opless channel: %s",
-                             sptr->name,
-                             chptr->chname);
+              sendto_ops_flag(UMODE_SERVNOTICE, "Hacked ops from %s on opless channel: %s",
+				     sptr->name,
+				     chptr->chname);
             }
 #endif
         }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/client.c ircd-hybrid-6.0/src/client.c
--- ircd-hybrid-6.0.orig/src/client.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/client.c	Tue Jun 19 16:45:34 2001
@@ -219,9 +219,8 @@
        * sendto_ops in it should never happen, and if it does, the 
        * hybrid team wants to hear about it
        */
-      sendto_ops(BH_FREE_ERROR_MESSAGE, cptr);
-      sendto_ops("Please report to the hybrid team! " \
-                 "ircd-hybrid@the-project.org");
+      sendto_ops_flag(UMODE_DEBUG, BH_FREE_ERROR_MESSAGE, cptr);
+      sendto_ops_flag(UMODE_DEBUG, "Please report to the dancer-hybrid team! opn-coders@vc.bc.ca");
 
       log(L_WARN, BH_FREE_ERROR_MESSAGE, cptr);
     }
@@ -323,14 +322,13 @@
                 {
                   if(IsConfElined(aconf))
                     {
-                      sendto_realops("D-line over-ruled for %s client is E-lined",
-                                 get_client_name(cptr,FALSE));
-                                 continue;
+                      sendto_ops_flag(UMODE_CCONN, "D-line over-ruled for %s client is E-lined",
+					     get_client_name(cptr,FALSE));
                       continue;
                     }
 
-		      sendto_ops_flag_butone(NULL, UMODE_SKILL, "%s confirms D-line of %s", me.name,
-					     get_client_name(cptr, FALSE));
+		  sendto_ops_flag(UMODE_SKILL, "%s confirms D-line of %s", me.name,
+					 get_client_name(cptr, FALSE));
 
                   dying_clients[die_index] = cptr;
 /* Wintrhawk */
@@ -372,7 +370,7 @@
 #ifdef GLINES
                   if( (aconf = find_gkill(cptr,cptr->username)) )
                     {
-		      sendto_ops_flag_butone(NULL, UMODE_SKILL, "%s confirms G-line of %s", me.name,
+		      sendto_ops_flag(UMODE_SKILL, "%s confirms G-line of %s", me.name,
                                  get_client_name(cptr, FALSE));
 
                       dying_clients[die_index] = cptr;
@@ -405,13 +403,13 @@
                     {
                       if(aconf->status & CONF_ELINE)
                         {
-                          sendto_realops("K-line over-ruled for %s client is E-lined",
-                                     get_client_name(cptr,FALSE));
-                                     continue;
+                          sendto_ops_flag(UMODE_CCONN, "K-line over-ruled for %s client is E-lined",
+						 get_client_name(cptr,FALSE));
+			  continue;
                         }
 
-		      sendto_ops_flag_butone(NULL, UMODE_SKILL, "%s confirms kill of %s", me.name,
-                                 get_client_name(cptr, FALSE));
+		      sendto_ops_flag(UMODE_SKILL, "%s confirms kill of %s", me.name,
+					     get_client_name(cptr, FALSE));
                       dying_clients[die_index] = cptr;
 
 /* Wintrhawk */
@@ -468,8 +466,8 @@
               aconf->port = 0;
               aconf->hold = CurrentTime + 60;
               add_temp_kline(aconf);
-              sendto_realops("Idle time limit exceeded for %s - temp k-lining",
-                         get_client_name(cptr,FALSE));
+              sendto_ops_flag(UMODE_SKILL, "Idle time limit exceeded for %s - temp k-lining",
+				     get_client_name(cptr,FALSE));
               continue;         /* and go examine next fd/cptr */
             }
         }
@@ -523,8 +521,8 @@
               if (IsServer(cptr) || IsConnecting(cptr) ||
                   IsHandshake(cptr))
                 {
-                  sendto_ops("No response from %s, closing link",
-                             get_client_name(cptr, MASK_IP));
+                  sendto_ops_flag(UMODE_SERVNOTICE, "No response from %s, closing link",
+					 get_client_name(cptr, MASK_IP));
                 }
               /*
                * this is used for KILL lines with time restrictions
@@ -606,7 +604,7 @@
            */
           if(cptr->flags2 & FLAGS2_ALREADY_EXITED)
             {
-              sendto_realops("Client already exited doing ping timeout %X",cptr);
+              sendto_ops_flag(UMODE_DEBUG, "Client already exited doing ping timeout %X",cptr);
             }
           else
             (void)exit_client(cptr, cptr, &me, ping_time_out_buffer );
@@ -628,7 +626,7 @@
            */
           if(cptr->flags2 & FLAGS2_ALREADY_EXITED)
             {
-              sendto_realops("Client already exited %X",cptr);
+              sendto_ops_flag(UMODE_DEBUG, "Client already exited %X",cptr);
             }
           else
             (void)exit_client(cptr, cptr, &me, dying_clients_reason[die_index]);
@@ -643,7 +641,7 @@
            */
           if(cptr->flags2 & FLAGS2_ALREADY_EXITED)
             {
-              sendto_realops("Client already exited %X",cptr);
+              sendto_ops_flag(UMODE_DEBUG, "Client already exited %X",cptr);
             }
           else
             (void)exit_client(cptr, cptr, &me, dying_clients_reason[die_index]);
@@ -1170,7 +1168,7 @@
   */
   if (IsMe(sptr))
     {
-      sendto_ops("ERROR: tried to exit me! : %s", comment);
+      sendto_ops_flag(UMODE_DEBUG, "ERROR: tried to exit me! : %s", comment);
       return;        /* ...must *never* exit self!! */
     }
   else if (IsServer(sptr))
@@ -1496,7 +1494,7 @@
       sptr->flags |= FLAGS_CLOSING;
       if (IsPerson(sptr))
         {
-          sendto_ops_flag_butone(NULL, UMODE_CCONN,
+          sendto_ops_flag(UMODE_CCONN,
 				 "Client exiting: %s (%s@%s) [%s] [%s] [%s]",
 				 sptr->name, sptr->username, sptr->host,
 #ifdef WINTRHAWK
@@ -1609,7 +1607,7 @@
 
       if (sptr->servptr == &me)
         {
-          sendto_ops_flag_butone(NULL, UMODE_SERVNOTICE, "%s was connected to %s for %d seconds.  %d/%d sendK/recvK.",
+          sendto_ops_flag(UMODE_SERVNOTICE, "%s was connected to %s for %d seconds.  %d/%d sendK/recvK.",
 				 sptr->name, &me.name, CurrentTime - sptr->firsttime,
 				 sptr->sendK, sptr->receiveK);
           log(L_NOTICE, "%s was connected for %d seconds.  %d/%d sendK/recvK.",
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/flud.c ircd-hybrid-6.0/src/flud.c
--- ircd-hybrid-6.0.orig/src/flud.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/flud.c	Tue Jun 19 16:45:48 2001
@@ -58,27 +58,27 @@
   switch(type)
     {
     case 1: /* classic CTCP */
-      sendto_ops_flag_butone(NULL, UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s (ctcp %i)",
+      sendto_ops_flag(UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s (ctcp %i)",
 			     fluder->name, fluder->username, fluder->host,
 			     fluder->user->server, fludee, fluder->repeatcount);
       break;
     case 2: /* repeating channel traffic */
-      sendto_ops_flag_butone(NULL, UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s (echo %i)",
+      sendto_ops_flag(UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s (echo %i)",
                        fluder->name, fluder->username, fluder->host,
                        fluder->user->server, fludee, fluder->repeatcount);
       break;
     case 3: /* repeating oneself */
-      sendto_ops_flag_butone(NULL, UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s (spam %i)",
+      sendto_ops_flag(UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s (spam %i)",
                        fluder->name, fluder->username, fluder->host,
                        fluder->user->server, fludee, fluder->repeatcount);
       break;
     case 4: /* insane message lengths */
-      sendto_ops_flag_butone(NULL, UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s (len %i)",
+      sendto_ops_flag(UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s (len %i)",
                        fluder->name, fluder->username, fluder->host,
                        fluder->user->server, fludee, fluder->lastlen);
       break;
     default:
-      sendto_ops_flag_butone(NULL, UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s",
+      sendto_ops_flag(UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s",
                        fluder->name, fluder->username, fluder->host,
                        fluder->user->server, fludee);
       break;
@@ -256,7 +256,7 @@
 
   if(cptr && !MyConnect(fluder))
     {
-      sendto_realops("check_for_flud() called for non-local client");
+      sendto_ops_flag(UMODE_DEBUG, "check_for_flud() called for non-local client");
       return 0;
     }
  
@@ -426,7 +426,7 @@
   if (blocking && fluder->repeatcount > KILLNUM)
     {
       sendto_ops_flag(UMODE_SKILL, "Flood countermeasure, dumping user %s",
-		      fluder->name);
+			     fluder->name);
       sendto_one(fluder, ":%s KILL %s :%s spam",
                  me.name, fluder->name, cptr->name);
       exit_client(fluder, fluder, &me, "Excessive spam");
@@ -442,7 +442,7 @@
 
   if((cptr == NULL) && (chptr == NULL))
     {
-      sendto_realops("free_fluders(NULL, NULL)");
+      sendto_ops_flag(UMODE_DEBUG, "free_fluders(NULL, NULL)");
       return;
     }    
  
@@ -476,7 +476,7 @@
                 
   if(badguy == NULL)
     {
-      sendto_realops("free_fludees(NULL)");
+      sendto_ops_flag(UMODE_DEBUG, "free_fludees(NULL)");
       return;
     }
   fludees = badguy->fludees;
@@ -489,7 +489,7 @@
       else
         {
           if(!MyConnect(fludees->value.cptr))
-            sendto_realops("free_fludees() encountered non-local client");
+            sendto_ops_flag(UMODE_DEBUG, "free_fludees() encountered non-local client");
           else
             remove_fluder_reference(&fludees->value.cptr->fluders, badguy);
         }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/ircd.c ircd-hybrid-6.0/src/ircd.c
--- ircd-hybrid-6.0.orig/src/ircd.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/ircd.c	Tue Jun 19 16:45:56 2001
@@ -368,7 +368,7 @@
   if ((CurrentTime = time(NULL)) == -1)
     {
       log(L_ERROR, "Clock Failure (%d)", errno);
-      sendto_ops("Clock Failure (%d), TS can be corrupted", errno);
+      sendto_ops_flag(UMODE_SERVNOTICE, "Clock Failure (%d), TS can be corrupted", errno);
       restart("Clock Failure");
     }
 
@@ -405,7 +405,7 @@
                   sprintf(to_send, 
                         "Entering high-traffic mode - (%.1fk/s > %dk/s)",
                                 (float)currlife, LRV);
-                  sendto_ops("%s", to_send);
+                  sendto_ops_flag(UMODE_SERVNOTICE, "%s", to_send);
                 }
             }
           else
@@ -419,7 +419,7 @@
                                 LIFESUX,
                                 (LIFESUX & 0x04) ?  " (TURBO)" : "",
                                 (int)LCF, (float)currlife);
-                  sendto_ops("%s", to_send);
+                  sendto_ops_flag(UMODE_SERVNOTICE, "%s", to_send);
                 }
             }
         }
@@ -430,7 +430,7 @@
             {
               LIFESUX = 0;
               if (NOISYHTM)
-                sendto_ops("Resuming standard operation . . . .");
+                sendto_ops_flag(UMODE_SERVNOTICE, "Resuming standard operation . . . .");
             }
         }
       lastrecvK = (long)me.receiveK;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/list.c ircd-hybrid-6.0/src/list.c
--- ircd-hybrid-6.0.orig/src/list.c	Wed Jun 20 03:42:15 2001
+++ ircd-hybrid-6.0/src/list.c	Tue Jun 19 16:46:03 2001
@@ -187,16 +187,16 @@
        */
       if (user->joined || user->refcnt < 0 ||
           user->invited || user->channel)
-      sendto_realops("* %#x user (%s!%s@%s) %#x %#x %#x %d %d *",
-                 cptr, cptr ? cptr->name : "<noname>",
-                 cptr->username, cptr->host, user,
-                 user->invited, user->channel, user->joined,
-                 user->refcnt);
+      sendto_ops_flag(UMODE_DEBUG, "WTF: * %#x user (%s!%s@%s) %#x %#x %#x %d %d *",
+			     cptr, cptr ? cptr->name : "<noname>",
+			     cptr->username, cptr->host, user,
+			     user->invited, user->channel, user->joined,
+			     user->refcnt);
 
       if(BlockHeapFree(free_anUsers,user))
         {
-          sendto_realops("list.c couldn't BlockHeapFree(free_anUsers,user) user = %lX", user );
-          sendto_realops("Please report to the hybrid team! ircd-hybrid@the-project.org");
+          sendto_ops_flag(UMODE_DEBUG, "list.c couldn't BlockHeapFree(free_anUsers,user) user = %lX", user );
+          sendto_ops_flag(UMODE_DEBUG, "Please report to the dancer-hybrid team! opn-coders@vc.bc.ca");
 #ifdef SYSLOG_BLOCK_ALLOCATOR 
           log(L_DEBUG,"list.c couldn't BlockHeapFree(free_anUsers,user) user = %lX", (long unsigned int) user);
 #endif
@@ -247,8 +247,8 @@
 {
   if(BlockHeapFree(free_Links,lp))
     {
-      sendto_realops("list.c couldn't BlockHeapFree(free_Links,lp) lp = %lX", lp );
-      sendto_realops("Please report to the hybrid team!");
+      sendto_ops_flag(UMODE_DEBUG, "list.c couldn't BlockHeapFree(free_Links,lp) lp = %lX", lp );
+      sendto_ops_flag(UMODE_DEBUG, "Please report to the hybrid team!");
     }
 }
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/listener.c ircd-hybrid-6.0/src/listener.c
--- ircd-hybrid-6.0.orig/src/listener.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/listener.c	Tue Jun 19 16:46:14 2001
@@ -373,8 +373,8 @@
      * slow down the whining to opers bit 
      */
     if((last_oper_notice + 20) <= CurrentTime) {
-      sendto_realops("All connections in use. (%s)", 
-                     get_listener_name(listener));
+      sendto_ops_flag(UMODE_SERVNOTICE, "All connections in use. (%s)", 
+			     get_listener_name(listener));
       last_oper_notice = CurrentTime;
     }
     send(fd, "ERROR :All connections in use\r\n", 32, 0);
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_admin.c ircd-hybrid-6.0/src/m_admin.c
--- ircd-hybrid-6.0.orig/src/m_admin.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/m_admin.c	Tue Jun 19 16:46:19 2001
@@ -114,9 +114,9 @@
     return 0;
 
   if (IsPerson(sptr))
-    sendto_realops_flag(UMODE_SPY,
-			"ADMIN requested by %s (%s@%s) [%s]", sptr->name,
-			sptr->username, sptr->host, sptr->user->server);
+    sendto_ops_flag(UMODE_SPY,
+			   "ADMIN requested by %s (%s@%s) [%s]", sptr->name,
+			   sptr->username, sptr->host, sptr->user->server);
   if ((aconf = find_admin()))
     {
       sendto_one(sptr, form_str(RPL_ADMINME),
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_away.c ircd-hybrid-6.0/src/m_away.c
--- ircd-hybrid-6.0.orig/src/m_away.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/m_away.c	Tue Jun 19 16:46:26 2001
@@ -115,8 +115,8 @@
   /* make sure the user exists */
   if (!(sptr->user))
     {
-      sendto_realops_flag(UMODE_DEBUG,
-			  "Got AWAY from nil user, from %s (%s)\n",cptr->name,sptr->name);
+      sendto_ops_flag(UMODE_DEBUG,
+			     "Got AWAY from nil user, from %s (%s)\n",cptr->name,sptr->name);
       return 0;
     }
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_chall.c ircd-hybrid-6.0/src/m_chall.c
--- ircd-hybrid-6.0.orig/src/m_chall.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/m_chall.c	Tue Jun 19 16:46:31 2001
@@ -74,7 +74,6 @@
 
 int m_chall(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
 {
-  static int sendflags[] = {UMODE_SERVNOTICE, UMODE_AUSPEX, UMODE_INVALID};
   char* salt = parc > 3 ? parv[3] : "";
   char* chall = parc > 2 ? parv[2] : "";
   char* host = parc > 1 ? parv[1] : "";
@@ -84,9 +83,9 @@
     {
       if (IsServer(cptr))
         {
-          sendto_realops("CHALL command from remote user %s -- %s is a hacked server",
-                          get_client_name(sptr,HIDE_IP),
-                          get_client_name(cptr,HIDE_IP));
+          sendto_ops_flag(UMODE_SERVNOTICE,"CHALL command from remote user %s -- %s is a hacked server",
+				 get_client_name(sptr,HIDE_IP),
+				 get_client_name(cptr,HIDE_IP));
         }
       else
         {
@@ -96,13 +95,12 @@
       return 0;
     }
 
-  sendto_realops_flags(sendflags, "CHALL received from %s, trying to use N:line for %s", get_client_name(cptr, SHOW_IP), host);
+  sendto_ops_flag(UMODE_SEEROUTING, "CHALL received from %s, trying to use N:line for %s", get_client_name(cptr, SHOW_IP), host);
 
   if (parc < 5)
     {
       sendto_one(cptr, "ERROR: Invalid challenge");
-      sendto_realops("Invalid CHALL from remote host for %s", host);
-      sendto_ops_flag(UMODE_DEBUG, "Got CHALL '%s' '%s' '%s'", host, chall, salt);
+      sendto_ops_flag(UMODE_SERVNOTICE, "Invalid CHALL from remote host for %s", host);
       return 0;
     }
 
@@ -112,14 +110,14 @@
 
   /* See if we got c and n lines. */
   if (!(n_conf = find_conf_by_name(host, CONF_NOCONNECT_SERVER))) {
-    sendto_ops("Challenge rejected. No N line for server %s", host);
+    sendto_ops_flag(UMODE_SERVNOTICE, "Challenge rejected. No N line for server %s", host);
     log(L_NOTICE, "Challenge rejected. No N line for server %s", host);
     sendto_one(cptr, "ERROR :Access denied. No N line"); 
     return exit_client(cptr, cptr, cptr, "Access denied. No N line");    
   } 
 
   if (!(c_conf = find_conf_by_name(host, CONF_CONNECT_SERVER))) {
-    sendto_ops("Challenge rejected. No C line for server %s", host);
+    sendto_ops_flag(UMODE_SERVNOTICE, "Challenge rejected. No C line for server %s", host);
     log(L_NOTICE, "Challenge rejected. No C line for server %s", host);
     sendto_one(cptr, "ERROR :Access denied. No C line"); 
     return exit_client(cptr, cptr, cptr, "Access denied. No C line");    
@@ -127,7 +125,7 @@
   
   /* Check if the ip matches the c/n IPs */
   if ( (cptr->ip.s_addr != c_conf->ipnum.s_addr) || (cptr->ip.s_addr != n_conf->ipnum.s_addr)) {
-    sendto_ops("Challenge rejected. C/N line IP doesn't match connection");
+    sendto_ops_flag(UMODE_SERVNOTICE, "Challenge rejected. C/N line IP doesn't match connection");
     log(L_NOTICE, "Challenge rejected. C/N line IP doesn't match connection");
     sendto_one(cptr, "ERROR :Access denied. C/N line don't match you"); 
     return exit_client(cptr, cptr, cptr, "Access denied. C/N line don't match");        
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_connect.c ircd-hybrid-6.0/src/m_connect.c
--- ircd-hybrid-6.0.orig/src/m_connect.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/m_connect.c	Tue Jun 19 16:46:36 2001
@@ -191,7 +191,7 @@
    */
   if (IsServer(cptr))
     {
-      sendto_ops_flag_butone(NULL, UMODE_SERVNOTICE,
+      sendto_ops_flag(UMODE_SERVNOTICE,
 			     "Remote CONNECT %s %s from %s",
 			     parv[1], parv[2] ? parv[2] : "",
 			     get_client_name(sptr, FALSE));
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_error.c ircd-hybrid-6.0/src/m_error.c
--- ircd-hybrid-6.0.orig/src/m_error.c	Sat Nov 18 19:11:12 2000
+++ ircd-hybrid-6.0/src/m_error.c	Tue Jun 19 16:46:48 2001
@@ -112,11 +112,11 @@
   if (IsPerson(cptr) || IsUnknown(cptr))
     return 0;
   if (cptr == sptr)
-    sendto_realops("ERROR :from %s -- %s",
-               get_client_name(cptr, FALSE), para);
+    sendto_ops_flag(UMODE_SERVNOTICE, "ERROR :from %s -- %s",
+			   get_client_name(cptr, FALSE), para);
   else
-    sendto_realops("ERROR :from %s via %s -- %s", sptr->name,
-               get_client_name(cptr,FALSE), para);
+    sendto_ops_flag(UMODE_SERVNOTICE, "ERROR :from %s via %s -- %s", sptr->name,
+			   get_client_name(cptr,FALSE), para);
   return 0;
 }
 
